#### read_until (11 of 24 overloads)

Read data into a streambuf until it contains a specified delimiter.

    template<
        typename SyncReadStream,
        typename Allocator>
    std::size_t read_until(
        SyncReadStream & s,
        asio::basic_streambuf< Allocator > & b,
        string_view delim);

This function is used to read data into the specified streambuf until the streambuf's get area contains the specified delimiter. The call will block until one of the following conditions is true:

- The get area of the streambuf contains the specified delimiter.
- An error occurred.

This operation is implemented in terms of zero or more calls to the stream's read_some function. If the streambuf's get area already contains the delimiter, the function returns immediately.

###### Parameters

s

  The stream from which the data is to be read. The type must support the SyncReadStream concept.

b

  A streambuf object into which the data will be read.

delim

  The delimiter string.

###### Return Value

The number of bytes in the streambuf's get area up to and including the delimiter.

###### Exceptions

asio::system_error

  Thrown on failure.

###### Remarks

After a successful read_until operation, the streambuf may contain additional data beyond the delimiter. An application will typically leave that data in the streambuf for a subsequent read_until operation to examine.

###### Example

To read data into a streambuf until a newline is encountered:

    asio::streambuf b;
    asio::read_until(s, b, "\r\n");
    std::istream is(&b);
    std::string line;
    std::getline(is, line);

After the `read_until` operation completes successfully, the buffer `b` contains the delimiter:

    { 'a', 'b', ..., 'c', '\r', '\n', 'd', 'e', ... }

The call to `std::getline` then extracts the data up to and including the newline (which is discarded), so that the string `line` contains:

    { 'a', 'b', ..., 'c', '\r' }

The remaining data is left in the buffer `b` as follows:

    { 'd', 'e', ... }

This data may be the start of a new line, to be extracted by a subsequent `read_until` operation.